Public Class Sample25
	Inherits System.Web.UI.Page
	Protected WithEvents AxpDataGrid1 As Axezz.WebControls.AxpDataGrid

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings("ConnectionString")

		' Setting Productname to a required field since the grid is unable to detect it on some Access databases
		Dim efi As Axezz.WebControls.EditFieldItem = New Axezz.WebControls.EditFieldItem
		efi.ColumnName = "ProductName"
		efi.Required = True
		AxpDataGrid1.SetEditField(efi)

		' This sample might seem a bit meaningless but it does show how the various events and methods can be used.....

		' A read only drop down always defaulting to 1 in BeforeInsertRecord/BeforeUpdateRecord
		AxpDataGrid1.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", True)
		Dim efi2 As Axezz.WebControls.EditFieldItem = New Axezz.WebControls.EditFieldItem
		efi2.ColumnName = "SupplierId"
		efi2.DefaultValue = 1
		efi2.IsReadOnly = True
		efi2.IsHardCoded = True		 ' needed when IsReadOnly = True and we want to alter/set the value in the BeforeInsertRecord/BeforeUpdateRecord
		AxpDataGrid1.SetEditField(efi2)

		' A hidden input field hard coded to 2 in BeforeInsertRecord/BeforeUpdateRecord
		Dim efi3 As Axezz.WebControls.EditFieldItem = New Axezz.WebControls.EditFieldItem
		efi3.ColumnName = "CategoryId"
		efi3.Visible = False
		AxpDataGrid1.SetEditField(efi3)
	End Sub

	Private Sub AxpDataGrid1_BeforeInsertRecord(ByVal sender As Object, ByVal e As Axezz.WebControls.UpdateRecordEventArgs) Handles AxpDataGrid1.BeforeInsertRecord
		ValidateFields()
		SetHardCodedValues()
	End Sub

	Private Sub AxpDataGrid1_BeforeUpdateRecord(ByVal sender As Object, ByVal e As Axezz.WebControls.UpdateRecordEventArgs) Handles AxpDataGrid1.BeforeUpdateRecord
		ValidateFields()
		SetHardCodedValues()
	End Sub

	Private Sub ValidateFields()
		If Not AxpDataGrid1.UpdateFields("QuantityPerUnit") Is Nothing Then
			If AxpDataGrid1.UpdateFields("QuantityPerUnit").ColumnValue.Trim.Length > 0 Then
				Dim test As Integer = -1
				Try
					test = Integer.Parse(AxpDataGrid1.UpdateFields("QuantityPerUnit").ColumnValue)
				Catch
					AxpDataGrid1.AbortCommandExecution()
					Dim edit1 As New Axezz.WebControls.EditFieldItem
					With edit1
						.ColumnName = "QuantityPerUnit"
						.HtmlAfter = "<font color='red'><strong>&nbsp;Not a number</strong></font>"
					End With
					AxpDataGrid1.SetEditField(edit1)
				End Try
				If test < 0 Then
					AxpDataGrid1.AbortCommandExecution()
					Dim edit1 As New Axezz.WebControls.EditFieldItem
					With edit1
						.ColumnName = "QuantityPerUnit"
						.HtmlAfter = "<font color='red'><strong>&nbsp;Not a positive number</strong></font>"
					End With
					AxpDataGrid1.SetEditField(edit1)
				End If
			End If
		End If
	End Sub

	Private Sub SetHardCodedValues()
		' Note! All UpdateFields must be present in the Select query. E.g. The column "CategoryId"
		If Not AxpDataGrid1.UpdateFields("SupplierId") Is Nothing Then
			AxpDataGrid1.UpdateFields("SupplierId").ColumnValue = "1"
		End If
		If Not AxpDataGrid1.UpdateFields("CategoryId") Is Nothing Then
			AxpDataGrid1.UpdateFields("CategoryId").ColumnValue = "2"
		End If
	End Sub
End Class
